Loading...
Searching...
No Matches
pcl::BilateralFilter< PointT > Class Template Reference
Module filters

A bilateral filter implementation for point cloud data. More...

`#include <pcl/filters/bilateral.h>`

Inheritance diagram for pcl::BilateralFilter< PointT >:

## Public Types

using | Ptr = shared_ptr< BilateralFilter< PointT > >
using | ConstPtr = shared_ptr< const BilateralFilter< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| BilateralFilter ()
| Constructor.
double | computePointWeight (const int pid, const Indices &indices, const std::vector< float > &distances)
| Compute the intensity average for a single point.
void | setHalfSize (const double sigma_s)
| Set the half size of the Gaussian bilateral filter window.
double | getHalfSize () const
| Get the half size of the Gaussian bilateral filter window as set by the user.
void | setStdDev (const double sigma_r)
| Set the standard deviation parameter.
double | getStdDev () const
| Get the value of the current standard deviation parameter of the bilateral filter.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Filter the input data and store the results into output.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::BilateralFilter< PointT >

A bilateral filter implementation for point cloud data.

Uses the intensity data channel.

Note
  For more information please see C. Tomasi and R. Manduchi. Bilateral Filtering for Gray and Color Images. In Proceedings of the IEEE International Conference on Computer Vision, 1998.

Author
  Luca Penasa

Definition at line 56 of file bilateral.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT >

using pcl::BilateralFilter< PointT >::ConstPtr = shared_ptr<const BilateralFilter<PointT> >

Definition at line 66 of file bilateral.h.

## Ptr

template<typename PointT >

using pcl::BilateralFilter< PointT >::Ptr = shared_ptr<BilateralFilter<PointT> >

Definition at line 65 of file bilateral.h.

## Constructor & Destructor Documentation

## BilateralFilter()

template<typename PointT >

pcl::BilateralFilter< PointT >::BilateralFilter | ( |  | ) |

inline

Constructor.

Sets sigma_s_ to 0 and sigma_r_ to MAXDBL

Definition at line 71 of file bilateral.h.

## Member Function Documentation

## applyFilter()

template<typename PointT >

void pcl::BilateralFilter< PointT >::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Filter the input data and store the results into output.

Parameters

  [out] | output | the resultant point cloud message

Implements pcl::Filter< PointT >.

Definition at line 76 of file bilateral.hpp.

References pcl::isXYZFinite().

## computePointWeight()

template<typename PointT >

double pcl::BilateralFilter< PointT >::computePointWeight | ( | const int | pid,
|  | const Indices & | indices,
|  | const std::vector< float > & | distances
| ) |  |

Compute the intensity average for a single point.

Parameters

  [in] | pid | the point index to compute the weight for
  [in] | indices | the set of nearest neighbor indices
  [in] | distances | the set of nearest neighbor distances

Returns
  the intensity average at a given point index

Definition at line 50 of file bilateral.hpp.

## getHalfSize()

template<typename PointT >

double pcl::BilateralFilter< PointT >::getHalfSize | ( |  | ) | const

inline

Get the half size of the Gaussian bilateral filter window as set by the user.

Definition at line 92 of file bilateral.h.

## getStdDev()

template<typename PointT >

double pcl::BilateralFilter< PointT >::getStdDev | ( |  | ) | const

inline

Get the value of the current standard deviation parameter of the bilateral filter.

Definition at line 104 of file bilateral.h.

## setHalfSize()

template<typename PointT >

void pcl::BilateralFilter< PointT >::setHalfSize | ( | const double | sigma_s | ) |

inline

Set the half size of the Gaussian bilateral filter window.

Parameters

  [in] | sigma_s | the half size of the Gaussian bilateral filter window to use

Definition at line 87 of file bilateral.h.

## setSearchMethod()

template<typename PointT >

void pcl::BilateralFilter< PointT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  [in] | tree | a pointer to the spatial search object.

Definition at line 111 of file bilateral.h.

## setStdDev()

template<typename PointT >

void pcl::BilateralFilter< PointT >::setStdDev | ( | const double | sigma_r | ) |

inline

Set the standard deviation parameter.

Parameters

  [in] | sigma_r | the new standard deviation parameter

Definition at line 99 of file bilateral.h.

The documentation for this class was generated from the following files:

- pcl/filters/bilateral.h
- pcl/filters/impl/bilateral.hpp